from machine import Pin, ADC
from time import sleep_ms
import time
import math
pi = math.pi #Definim pi
t1_start = time.ticks_ms() # activa el comptador de temps
t1_stop = 0
contadortalls=0
pinAnalogic = ADC(Pin(36)) # Emprarem ADC "analog to digital conversion" al pin 36
pinAnalogic.atten(ADC.ATTN_11DB)  # Voltatge max: 3.3v llavors eixida sera 4095
punterLaser= Pin(18, Pin.OUT ) #  Activarel el làser des d_aquest GPIO
valorLecturaLDR = 0 #Inicialitzem el primer valor de LDR
# Declarem les llistes/matrius
C = [] # Llista contadortalls
t = [] # Llista periode
i=1 # valor inicial de i
pasLlum= True; #Valor inicial doncs la bola no talla el feix laser
while i>0: # Bucle infinit
      punterLaser.value(1) #Activem el punter Laser
      #sleep_ms(50)# Esperem 50 ms per donar temps al programa a engegar el punter
      valorLecturaLDR = pinAnalogic.read() # llegim pinAnalogic.read() i ho guardem en la variable valorAnalogicLlegit   
      if valorLecturaLDR > 1500:
          print("Feix NO tallat ja que valorLecturaLDR=",valorLecturaLDR) # Imprimim el valor de la variable
          pasLlum= True;#Bola pendol no talla el feix laser
          print("   ") # Linia en blanc
      if valorLecturaLDR < 1500 and pasLlum==True:
          print("Feix Laser SI tallat ja que valorLecturaLDR=",valorLecturaLDR) # Imprimim el valor de la variable
          print("   ") # Linia en blanc
          t1_stop = time.ticks_ms() # activa el comptador final
          delta = time.ticks_diff(t1_stop, t1_start)
          t.append(delta)
          contadortalls=contadortalls+1
          C.append(contadortalls)
          pasLlum= False; #Bola talla el feix laser. no volem comptar-la 2 vegades o mes per pas
      if contadortalls > 39:
          #Escrivim la matriu/llista al terminal
          print (" ") # Linia en blanc
          print("La llista C = ", C)
          print (" ") # Linia en blanc
          print("La llista t = ", t)
          punterLaser.value(0)# Parem el punter laser
          print(" El valor del periode en ms per les (40) semioscilacions = ", t[39])
          # t[40] es el periode en ms per a 20 oscilacions completes
          L=0.385
          ts=t[39]/1000/20
          # ts es el periode en segons per a 20 oscilacions completes
          print(" El valor ts es = ", ts)
          tsq=ts*ts
          # tsq es el quadrat de ts
          print(" El valor ts² es = ", tsq)
          g=4*pi*pi*L/tsq #Formula treta del pendol simple
          print(" El valor calculat de «g» es = ", g, " m/s²")
          sleep_ms (40000)
          #Reiniclialitzen les variables
          t1_start = time.ticks_ms() # activa el comptador de temps
          i=1 # valor inicial de i
          contadortalls=0
          pasLlum= True; #Valor inicial doncs la bola no talla el feix laser
          C = [] # Llista contadortalls
          t = [] # Llista periode
      print("iteracio=", i) # Missatge amb la iteracio num = i      
      print("   ") # Linia en blanc
      i+=1 # i=i+1 Augmentem el valor de i amb 1 unitat